'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_basic_1.inc,v $
'*
'*  $Revision: 1.1.2.2 $
'*
'*  last change: $Author: jsi $ $Date: 2003/09/05 06:50:53 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
' **
' ** owner : joerg.skottke@sun.com
' **
' ** short description : check macro-dialogs / BASIC-IDE ( 1. part )
' **
'*******************************************************************************
' **
' #1 tMakro_In_All_Apps               ' open BASIC-IDE in all Applications
' #1 tMakro_Dialog                    ' update-test for macro-dialog
' #1 tMakro_Names                     ' check naming convention for modules
' #1 tBasic_IDE_NewModule             ' working with a new module
' #1 tBasic_IDE_NewDialog             ' working with a new dialog
' #1 tBasic_IDE_Breakpoint            ' working with breakpoints
' **
'\******************************************************************************

testcase tMakro_In_All_Apps
    Dim i as Integer
    Dim bBug as Boolean
    bBug = FALSE
    '///open tools/macro in all applications
    for i=1 to 7
        select case i
            case 1 : gApplication = "Writer"
            case 2 : gApplication = "Calc"
            case 3 : gApplication = "Impress"
            case 4 : gApplication = "Draw"
            case 5 : gApplication = "MasterDoc"
            case 6 : gApplication = "HTML"
            case 7 : gApplication = "Math"
        end select      
        '///open a new document
        printlog Chr(13) + gApplication
        Call hNewDocument
        '///+ tools/macro and insert a new module for this document
        try
            CreateNewModuleForDoc
        catch
            warnlog "Tools/Macro not be activated => BUG!"
            FileClose
            sleep(1)
            goto endsub
        endcatch
        '///+ close the BASIC-IDE
        sleep(1)
        printlog "close the BASIC-IDE"
        FileClose                                         ' close the BASIC IDE
        sleep(1)
        Kontext "Navigator"
            if Navigator.Exists(5) then Navigator.Close
        '///+ close the changed document ( a messagebox should warn you about changes, if not it is a bug! )
        sleep(1)
        FileClose                                         ' close the document with new Basic
        sleep(1)
        printlog "close the changed document => a messagebox should warn you about changes!"
        Kontext "Messagebox"
            if MessageBox.Exists( 1 ) then
                MessageBox.No
            else
                warnlog "A new module is inserted for this document ( " + gApplication  + ", but no messagebox at closing the doc! => BUG"
            end if
    next i   
   '///in a math-document tools/macro must be disabled
endcase

'-------------------------------------------------------------------------

testcase tMakro_Dialog
    '///test the macro related functions and dialogs
    Dim XLBFILE as String
    Dim iTemp as Integer
    Dim i as Integer
        
    XLBFILE = gTesttoolPath + "framework\basic\input\AppLibrary1\script.xlb"
    const ICWAIT as Integer = 1
   
    gApplication = "Writer"

    '///+Open a new document
    printlog( "Open a new document" )
    Call hNewDocument   
    '///create a new module for the new document ( named TTModule )
    printlog " - create a new module "
    Call CreateNewModuleForDoc()
    '///+close the basic-IDE
    printlog " - close the basic-IDE"
    Kontext "MacroBar"
        if MacroBar.Exists() then
            FileClose
        else
            warnlog( "The Macro-Document is not open!" )
            printlog( "Now the test runs in other errors!" )
        end if
        '///+tools / macro and select the new module
        Call SelectTheLastModule ( FALSE, FALSE )
        printlog " - organize"
        '///+organize
        Verwalten.Click()
        '///+activate TabModule on it 'New Module' / 'New Dialog'
        printlog " - activate TabModule"
    Kontext
        Active.SetPage( TabModule )
    Kontext "TabModule"
        '///+create a new module
        printlog " - press 'new module'"
        NeuesModul.Click()
        '///+cancel the 'New Module' dialog
        printlog( " - cancel the dialog" )
    Kontext "NeuesModul"
        NeuesModul.Cancel()
        '///+create a 'New Dialog'
    Kontext "TabModule"
        printlog " - press 'new dialog'"
        NeuerDialog.Click()
        '///+cancel the dialog
        printlog( " - cancel the dialog" )
    Kontext "NeuerDialog"
        NeuerDialog.Cancel()
        '///+activate TabLibrary on it 'New' / 'Password' / 'Delete' / 'Append' / 'Edit'
        printlog " - select the libraries Tab"
    Kontext
        Active.SetPage( TabBibliotheken )
        '///+press 'New' on the libraries tab
        printlog " - press 'New' on the libraries tab"
    Kontext "TabBibliotheken"
        Neu.Click()
        '///+close the dialog with 'OK'
        printlog( " - close the dialog with 'OK'" )
    Kontext "NeueBibliothek"
        Call DialogTest (NeueBibliothek)
        NeueBibliothek.OK()
        printlog( " - get the number of items from the libraries-list" )
    Kontext "TabBibliotheken"
        iTemp = Bibliotheksliste.getItemCount()
        printlog( " - Number of entries: " + iTemp )
        '///+Append a library by pressing 'Append'
        printlog " - append a xlb-file"
    Kontext "TabBibliotheken"
        Hinzufuegen.Click()
        '///+select a valid library and open it
        printlog( " - Select 'AppLibrary1/script.xlb' from the files list" )   
    Kontext "OeffnenDlg"
        Dateiname.SetText( ConvertPath ( XLBFILE ) )
        Oeffnen.Click()
        sleep(2)
    Kontext "AppendLibraries"
        Call DialogTest (AppendLibraries) 
        '///+Make sure 'Insert as Reference' is unchecked
        printlog( " - Ensure 'Insert as Reference' is unchecked" )
    Kontext "AppendLibraries"
        if ( InsertAsReference.IsChecked() = TRUE ) then
            InsertAsReference.UnCheck()
        end if
        '///+check 'Replace Existing Library'
        printlog( " - check 'Replace existing library'" )
        if ( ReplaceExistingLibraries.IsChecked() = FALSE ) then
            ReplaceExistingLibraries.Check()
        end if
        '///+press 'OK' to append the library
        printlog( " - press 'OK' to append the library" )
    Kontext "AppendLibraries"
        AppendLibraries.OK()
        sleep( ICWAIT )
        printlog( " - get the number of items from the libraries-list" )
    Kontext "TabBibliotheken"
        iTemp = Bibliotheksliste.getItemCount()
        printlog( " - Number of entries: " + iTemp )
        printlog( " - select the first item" )
        Bibliotheksliste.TypeKeys( "<HOME>" )
        '///+Select 'AppLibrary1' and click 'Password'
        printlog( " - List of registered libraries:" )
        for i = 1 to ( iTemp )   
            printlog( "   Name: '" + Bibliotheksliste.getSelText() + "'" )
            if ( Bibliotheksliste.getSelText() = "AppLibrary1" ) then      
                Kontext "TabBibliotheken"
                    printlog( " - set a password for AppLibrary1" )
                    sleep( ICWAIT )
                    i = 1000 ' break the loop
                    if Passwort.IsEnabled then
                        Passwort.Click()
                        Kontext "PasswortAendern"
                            Call DialogTest ( PasswortAendern )
                            PasswortAendern.Cancel()            
                        Kontext "TabBibliotheken" 'back to library-dialog
                    else
                        warnlog( "Password is disabled for 'AppLibrary1'" )
                    end if
            end if
            Bibliotheksliste.Typekeys( "<DOWN>" ) 'next item 
        next i 
        '///+delete the inserted library
        printlog( " - delete 'AppLibrary1'" )
        Kontext "TabBibliotheken"
            Loeschen.Click()   
            '///+close the warning
            printlog( " - close the warning" )
        Kontext "Active"
            if Active.Exists then Active.Yes()
            '///+after edit the Basic-IDE must be open
            '///+close it
        Kontext "TabBibliotheken"
            printlog " - press 'edit' on 'Libraries'-tab"
            Bearbeiten.Click
            sleep( ICWAIT * 5 )
        Kontext "MacroBar"
            if MacroBar.Exists() then
                '///+Close the basic IDE
                printlog " - close the basic-document"
                FileClose
                Kontext "Active"
                    if Active.Exists ( 2 ) then
                        warnlog "Unexpected dialog: '" + Active.getText () + "'"
                        printlog "- The file should be saved without confirmation"
                        Active.OK()       
                        Kontext "FileSaveAs"
                            Dateiname.setText( "dumbo" )
                            Speichern.Click ()
                    end if    
            else
                warnlog("The Macro-Document is not open!")
                printlog("Now the test runs in other errors!")
            end if
        '///tools / macro
        printlog( " - tools / macro" )
        ToolsMacro   
        '///+go to the last macro in the list
        printlog( " - select the last macro from the list" )
        Kontext "Makro"
            MakroAus.TypeKeys( "<PageDown><PageDown><PageDown>" )
            '///+organize
            printlog( " - press 'Organize'" )
            try
                '///+Assign the macro by pressing 'Assign'
                printlog( " - Assign the macro" )
                Zuordnen.Click ()     
            catch   
                warnlog "The 'Assign'-Button is disabled. Perhaps Bugid #106853#"
                printlog " - The macro has not been added to the list."     
            endcatch
            '///+activate all tapages and cancel the tabdialog
            printlog " - activate all tabpages and cancel the tabdialog"
        Kontext
            Active.SetPage TabMenu
            sleep(1)
            Active.SetPage TabTastatur
            sleep(1)
            Active.SetPage TabStatusleiste
            sleep(1)
            Active.SetPage TabSymbolleisten
            sleep(1)
            Active.SetPage TabEreignisse
        Kontext "TabEreignisse"
            sleep(1)   
            TabEreignisse.Cancel()
        '///+run
        printlog " - run"
        Kontext "Makro"
            Ausfuehren.Click()
            sleep(3)
            '///tools / macro
        printlog "tools / macro"
        ToolsMacro
        Kontext "Makro"
            MakroAus.TypeKeys "<PageDown>" 
            '///+delete the new module
            printlog "- delete the new module"
            Loeschen.Click
            '///+close the warning
            printlog( " - close the warning" )
            Kontext "Active"
                Active.Yes   
                '///+close the macro dialog
                printlog( " - close the macro dialog" )
            Kontext "Makro"
                Makro.Close
                '///+Close the document
                printlog( "Close the document" )
        Call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tMakro_Names
    Dim i as Integer
    Dim sSeperator as String
    '///check the name conventions for modules
    '///open a new writer document
    printlog "open a new writer-doc"
    gApplication = "Writer"
    Call hNewDocument
    '///tools / macro => select the new document
    Call SelectTheLastModule ( FALSE, FALSE )
    Neu.Click
    for i=1 to 20
        select case i
            case 1  : sSeperator = "-"
            case 2  : sSeperator = "."
            case 3  : sSeperator = ","
            case 4  : sSeperator = "+"
            case 5  : sSeperator = ":"
            case 6  : sSeperator = "!"
            case 7  : sSeperator = "$"
            case 8  : sSeperator = "("
            case 9  : sSeperator = ")"
            case 10 : sSeperator = "="
            case 11 : sSeperator = "?"
            case 12 : sSeperator = "*"
            case 13 : sSeperator = "��Ș"
            case 14 : sSeperator = "����"
            case 15 : sSeperator = "���"
            case 16 : sSeperator = "����"
            case 17 : sSeperator = "��Ș"
            case 18 : sSeperator = "����"
            case 19 : sSeperator = "��ë"
            case 20 : sSeperator = " "
        end select
        '///+click new and insert 'tt?module' with forbidden signes
        '///+- tested forbidden signes are ( only one for each test name ) :
        '///+- '-', '.', ',', '+', ':', '!', '$', '(', ')', '=', '?', '*', '��Ș', '����', '���', '?', '����', '��ë', ' '
        '///+=> '?' is not allowed => a messagebox must come up => OK
        printlog "- insert 'tt" + sSeperator + "module' and click OK => warning box must come up => OK"
        Kontext "NeuesModul"
            Modulname.SetText "tt" + sSeperator + "module"
            NeuesModul.OK
            Kontext "Active"
                if Active.Exists then
                    Active.OK
                    Kontext "NeuesModul"
                else
                    warnlog "tt" + sSeperator + "module can be created => BUG : '" + sSeperator + "' in module names are not allowed!"
                    Kontext "Makro"
                        if Makro.Exists then Macro.Close
                            Kontext "BasicIDE"
                                if EditWindow.Exists then 
                                    Call hCloseDocument
                                end if
                                goto endsub                                                     ' if an error occured => testcase ends
                        end if
    next i
    '///+close the naming dialog
    Kontext "NeuesModul"
        if NeuesModul.Exists then NeuesModul.Cancel
        '///+close the macro dialog
    Kontext "Makro"
        if Makro.Exists then Makro.Close
        '///+close the last document
    Call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tBasic_IDE_NewModule
    Dim sOld as String
    '///working with new modules
    '///open a new writer-doc
    printlog "open a new writer-doc"
    gApplication = "Writer"
    Call hNewDocument
    '///create a new module for the new document ( named TTModule )
    printlog "create a new module "
    Call CreateNewModuleForDoc
    '///insert a short script ( only one print-command )
    printlog "create a new module "
    Kontext "BasicIDE"
        EditWindow.TypeKeys "<Mod1 a>"
        EditWindow.TypeKeys "<Delete>"
        EditWindow.TypeKeys "'# This is a short testscript for automated testing!<return><return>"
        EditWindow.TypeKeys "sub main<return><return>"
        EditWindow.TypeKeys "print " + Chr (34) + "hallo" + Chr (34) + "<Return><Return>"
        EditWindow.TypeKeys "<Home>end sub<return>"
        '///new module
        '///+insert a new module ( context menu on tab-bar )
        printlog "insert a new module ( context menu on tab-bar )"
        Tabbar.OpenContextMenu
        hMenuSelectNr(1)
        sleep(1)
        hMenuSelectNr(1)
        sleep(2)
        '///+check if a new module is open
        printlog "  check if a new module is open"
        EditWindow.TypeKeys "<Up>", 20
        EditWindow.TypeKeys "<Home><Shift End>"
        if Instr ( GetClipboardText, "automated" ) <> 0 then Warnlog "Perhaps no new module will be opened!"
        EditWindow.TypeKeys "<Mod1 a>"
        EditWindow.TypeKeys "<Delete>"
        EditWindow.TypeKeys "'# a second module for automated testing!<return><return>"
        printlog "  get the name of the new module"
        Tabbar.OpenContextMenu
        hMenuSelectNr(5)
        sleep(1)
        Kontext
            Active.SetPage TabModule
        Kontext "TabModule"
            sOld = Modulliste.GetSelText
            TabModule.Close
            '///+rename the module ( context menu on tab-bar )
            printlog "  rename the module ( context menu on tab-bar )"
        Kontext "BasicIDE"
            Tabbar.OpenContextMenu
            hMenuSelectNr(3)
            sleep(2)
            '///+- test different namings ( with space, with '-' )
            printlog "    test different namings ( with space, with '-' )"
            Tabbar.TypeKeys "<Home><Shift End>ttModule 2<Return>", True
        Kontext "Active"
            if Active.Exists then
                Active.OK
            else
                warnlog "Spaces in module names are allowed?!"
            end if
            sleep(1)
        Kontext "BasicIDE"
            Tabbar.TypeKeys "<Home><Shift End>tt-Module2<Return>", True
        Kontext "Active"
            if Active.Exists then
                Active.OK
            else
                warnlog "'-' in module names are allowed?!"
            end if
            sleep(1)
        Kontext "BasicIDE"
            Tabbar.TypeKeys "<Home><Shift End>ttModule2<Return>", True
            sleep(1)
            printlog "  check the new name"
            Tabbar.OpenContextMenu
            hMenuSelectNr(5)
            sleep(1)
        Kontext
            Active.SetPage TabModule
        Kontext "TabModule"
            if Modulliste.GetSelText <> "ttModule2" then
                if Modulliste.GetSelText = sOld then
                    warnlog "The name is not changed, it is the old name!"
                else
                    warnlog "The name is not changed correctly! The name should be : 'ttModule2' it is : " + Modulliste.GetSelText
                end if
            end if
            TabModule.Close
            '///+hide the module ( context menu on tab-bar )
            printlog "  hide the module ( context menu on tab-bar )"
        Kontext "BasicIDE"
            Tabbar.OpenContextMenu
            hMenuSelectNr(4)
            sleep(1)
            EditWindow.TypeKeys "<Up>", 20
            EditWindow.TypeKeys "<Home><Shift End>"
            if Instr ( GetClipboardText, "automated" ) <> 0 then Warnlog "Perhaps the new module isn't hide!"
            '///+activate the hide module with module-dialog ( context menu on tab-bar last entry )
            printlog "  activate the hide module with module-dialog ( context menu on tab-bar last entry )"
            Tabbar.OpenContextMenu
            hMenuSelectNr(5)
            sleep(1)
        Kontext
            Active.SetPage TabModule
        Kontext "TabModule"
            Modulliste.TypeKeys "<Down>"
            if Modulliste.GetSelText <> "ttModule2" then
                Modulliste.TypeKeys "<up>"
                if Modulliste.GetSelText <> "ttModule2" then
                    Modulliste.TypeKeys "<up>"
                    if Modulliste.GetSelText <> "ttModule2" then
                        warnlog "Test cannot select the hide module"
                    end if
                end if
            end if
            Bearbeiten.Click
            sleep(1)
        Kontext "BasicIDE"
            EditWindow.TypeKeys "<Up>", 20
            EditWindow.TypeKeys "<Home><Shift End>"
            if Instr ( GetClipboardText, "second" ) <> 0 then Warnlog "Perhaps the hide module is not active!"
            '///+delete the module ( context menu on tab-bar )
            printlog "  delete the module ( context menu on tab-bar )"
            Tabbar.OpenContextMenu
            hMenuSelectNr(2)
            sleep(1)
            '///+- choose 'NO' at messagebox => module should not be deleted
            printlog "    NO at messagebox"
        Kontext "Active"
            if Active.Exists then
                Active.No
            else
                warnlog "No warning after deleting a module!"
            end if
        Kontext "BasicIDE"
            EditWindow.TypeKeys "<Up>", 20
            EditWindow.TypeKeys "<Home><Shift End>"
            if Instr ( GetClipboardText, "second" ) <> 0 then Warnlog "Perhaps the module is deleted with 'NO'!"
            '///+- choose 'Yes' at messagebox => module should be deleted
            printlog "    YES at messagebox"
            Tabbar.OpenContextMenu
            hMenuSelectNr(2)
            sleep(1)
        Kontext "Active"
            if Active.Exists then
                Active.Yes
            else
                warnlog "No warning after deleting a module!"
            end if
        Kontext "BasicIDE"
            EditWindow.TypeKeys "<Up>", 20
            EditWindow.TypeKeys "<Home><Shift End>"
            if Instr ( GetClipboardText, "automated" ) <> 0 then Warnlog "Perhaps no new module will be opened!"
            '///+close BasicIDE and the new writer-doc
            printlog "close BasicIDE and the new writer-doc"
        Call hCloseDocument
    Call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tBasic_IDE_NewDialog
 Dim sOld as String

'///working with new modules
'///open a new writer-doc
  printlog "open a new writer-doc"
   gApplication = "Writer"
   Call hNewDocument

'///create a new module for the new document ( named TTModule )
  printlog "create a new module "
   Call CreateNewModuleForDoc

'///insert a short script ( only one print-command )
  printlog "create a new module "
   Kontext "BasicIDE"
   EditWindow.TypeKeys "<Mod1 a>"
   EditWindow.TypeKeys "<Delete>"

   EditWindow.TypeKeys "'# This is a short testscript for automated testing!<return><return>"
   EditWindow.TypeKeys "sub main<return><return>"
   EditWindow.TypeKeys "print " + Chr (34) + "hallo" + Chr (34) + "<Return><Return>"
   EditWindow.TypeKeys "<Home>end sub<return>"

'///new dialog
'///+insert a new dialog ( context menu on tab-bar )
  printlog "insert a new dialog ( context menu on tab-bar )"
   Tabbar.OpenContextMenu
   hMenuSelectNr(1)
   sleep(1)
   hMenuSelectNr(2)
   sleep(2)

'///+check if a new dialog is open
   if DialogWindow.Exists (2) <> TRUE then Warnlog "No dialog window is shown!"

  printlog "  get the name of the new dialog"
   Tabbar.OpenContextMenu
   hMenuSelectNr(3)
   sleep(1)
   Tabbar.TypeKeys "<Home><Shift End><Mod1 c><Escape>", True
   sOld = GetClipboardText

'///+rename the dialog ( context menu on tab-bar )
  printlog "  rename the dialog ( context menu on tab-bar )"
   Kontext "BasicIDE"
   Tabbar.OpenContextMenu
   hMenuSelectNr(3)
   sleep(1)

'///+- test different namings ( with space, with '-' )
  printlog "    test different namings ( with space, with '-' )"
   Tabbar.TypeKeys "<Home><Shift End>ttDialog 2<Return>", True
   Kontext "Active"
   if Active.Exists then
      Active.OK
   else
      Warnlog "Spaces in dialog names are allowed?!"
   end if
   sleep(2)

   Kontext "BasicIDE"
   Tabbar.TypeKeys "<Home><Shift End>tt-Dialog2<Return>", True
   Kontext "Active"
   if Active.Exists then
      Active.OK
   else
      Warnlog "'-' in dialog names are allowed?!"
   end if
   sleep(2)

   Kontext "BasicIDE"
   Tabbar.TypeKeys "<Home><Shift End>ttDialog2<Return>", True
   sleep(2)

  printlog "  check the new name"
   Tabbar.OpenContextMenu
   hMenuSelectNr(5)
   sleep(1)
  Kontext
   Active.SetPage TabModule
   Kontext "TabModule"
   Kontext "TabModule"
   Modulliste.TypeKeys "<Down>", 4
   if Modulliste.GetSelText <> "ttDialog2" then
      if Modulliste.GetSelText = sOld then
         Warnlog "The name is not changed, it is the old name!"
      else
         Modulliste.TypeKeys "<up>"
         if Modulliste.GetSelText <> "ttDialog2" then
             Warnlog "The name is not changed correctly! The name should be : 'ttDialog2' it is : " + Modulliste.GetSelText
         end if
      end if
   end if
   TabModule.Close

'///+hide the dialog ( context menu on tab-bar )
  printlog "  hide the dialog ( context menu on tab-bar )"
   Kontext "BasicIDE"
   Tabbar.OpenContextMenu
   hMenuSelectNr(4)
   sleep(2)

   if DialogWindow.Exists (2) = TRUE then Warnlog "The dialog window is not hide!"

'///+activate the hide module with module-dialog ( context menu on tab-bar last entry )
  printlog "  activate the hide module with module-dialog ( context menu on tab-bar last entry )"
   Tabbar.OpenContextMenu
   hMenuSelectNr(5)
   sleep(1)
   Kontext
   Active.SetPage TabModule
   Kontext "TabModule"
   Modulliste.TypeKeys "<Down>"
   if Modulliste.GetSelText <> "ttDialog2" then
      Modulliste.TypeKeys "<up>"
      if Modulliste.GetSelText <> "ttDialog2" then
         Modulliste.TypeKeys "<up>"
         if Modulliste.GetSelText <> "ttDialog2" then
            Warnlog "Test cannot select the hide module"
         end if
      end if
   end if
   Bearbeiten.Click

   Kontext "BasicIDE"
   if DialogWindow.Exists (2) <> TRUE then Warnlog "Perhaps the hide dialog is not active!"

'///+delete the module ( context menu on tab-bar )
  printlog "  delete the Dialog ( context menu on tab-bar )"
   Tabbar.OpenContextMenu
   hMenuSelectNr(2)
   sleep(1)

'///+- choose 'NO' at messagebox => dialog should not be deleted
  printlog "    NO at messagebox"
   Kontext "Active"
   if Active.Exists then
      Active.No
   else
      Warnlog "No warning after deleting a dialog!"
   end if
   Kontext "BasicIDE"
   if DialogWindow.Exists (2) <> TRUE then Warnlog "Perhaps the dialog-windows is deleted with 'NO'!"

   Tabbar.OpenContextMenu
   hMenuSelectNr(2)
   sleep(1)

'///+- choose 'Yes' at messagebox => dialog should be deleted
  printlog "    YES at messagebox"
   Kontext "Active"
   if Active.Exists then
      Active.Yes
   else
      Warnlog "No warning after deleting a dialog!"
   end if

   Kontext "BasicIDE"
   if DialogWindow.Exists (2) = TRUE then Warnlog "Perhaps the dialog-windows is not deleted!"

'///+close BasicIDE and the new writer-doc
  printlog "close BasicIDE and the new writer-doc"
   hCloseDocument
   hCloseDocument

endcase

'-------------------------------------------------------------------------

testcase tBasic_IDE_Breakpoint
    Dim i as Integer, yJump as Integer
    Dim iMenuCountBrkPoint as integer
    Dim iCountOfBrkItems as integer
    Dim sBrkPoiListEntry as string

    '///Working with breakpoints
    '///Open a new Writer document
    printlog "open a new writer-doc"
    gApplication = "Writer"
    Call hNewDocument
    '///Create a new module for the new document named <i>TTModule</i>
    printlog "create a new module "
    Call CreateNewModuleForDoc
    '///Insert a short script (only one print-command)
    printlog "insert a short script"
    Kontext "BasicIDE"
        EditWindow.TypeKeys "<MOD1 a>"
        EditWindow.TypeKeys "<DELETE>"
        EditWindow.TypeKeys "'# This is a short testscript for automated testing!<return><return>"
        EditWindow.TypeKeys "sub main<RETURN><RETURN>"
        EditWindow.TypeKeys "print " & Chr (34) & "hallo" + Chr (34) & "<RETURN><RETURN>"
        EditWindow.TypeKeys "<HOME>end sub<RETURN>"
        '///Insert breakpoints with doubleclick
        printlog "insert breakpoints with doubleclick"
        '///+Try to insert a breakpoint at a documentation line  => no breakpoint
        printlog "- set a breakpoint at documentation line  => no breakpoint"
        BreakPointsWindow.MouseDoubleClick ( 50, 2 )
        sleep(1)
        '///+try to insert a breakpoint at a code line  => breakpoint
        printlog "- set a breakpoint at code line"
        for i=1 to 50
            EditWindow.MouseDoubleClick ( 2, 2*i )
            try
                EditCopy
            catch
                SetClipboard ( "" )
            endcatch
            if lcase ( GetClipboardText ) = "sub" then
                BreakPointsWindow.MouseDoubleClick ( 50, 2*i )
                yJump = 2*i
                i=50
            end if
        next i
        '///check the context menu of breakpoints ( in breakpoint window )
        printlog "check the context menu of breakpoints ( in breakpoint window )"
        '///+move the mouse over the breakpoint and open the context menu ( should be 2 entries )
        BreakPointsWindow.MouseMove ( 50, yJump )
        BreakPointsWindow.OpenContextMenu TRUE
        iCountOfBrkItems = 0
        iCountOfBrkItems = hMenuItemGetCount
        if iCountOfBrkItems <> 2 then
            warnlog "Perhaps no breakpoint has been inserted or the mouse is not over the breakpoint => 2 entries are not in the context menu!"
            hMenuClose
        else
            printlog "- deactivate the breakpoint"
            '///+deactivate the breakpoint
            printlog "- deactivate the breakpoint"
            hMenuSelectNr(1)
            sleep(1)
            printlog "- activate the breakpoint"
            '///+open the contextmenu again and activate the breakpoint
            printlog "- activate the breakpoint"
            BreakPointsWindow.OpenContextMenu TRUE
            hMenuSelectNr(1)
            sleep(1)
            printlog "- open the breakpoint dialog"
            '///+open the contextmenu again and open the breakpoint dialog
            printlog "- open the breakpoint-dialog ( properties in context menu ) and close it"
            BreakPointsWindow.OpenContextMenu TRUE
            hMenuSelectNr(2)
            sleep(1)
            Kontext "Breakpoints"
                Call DialogTest (Breakpoints)
                '///+check the number of breakpoints ( should be only one )
                iCountOfBrkItems = 0
                iCountOfBrkItems = BreakpointsList.GetItemCount
                if iCountOfBrkItems <> 1 then
                    warnlog "There is not 1 breakpoint, there are " & iCountOfBrkItems & " breakpoints! => bug!"
                else
                    BreakpointsList.Select(1)
                    sBrkPoiListEntry = BreakpointsList.GetSelText
                    if Right (sBrkPoiListEntry , 1 ) <> 3 then warnlog "The breakpoint is not at line 3, it is on line " & Right (sBrkPoiListEntry , 1) & "!"
                end if
                Breakpoints.Cancel
            '///check if active and inactive breakpoint are shown correct in the dialog
            printlog "check if active and inactive breakpoints are shown correct in breakpoints dialog"
            Kontext "BasicIDE"
                BreakPointsWindow.MouseMove (50, yJump)
                BreakPointsWindow.OpenContextMenu TRUE
                '///+open the context menu over the breakpoint and uncheck 'active'
                printlog "- inactive"
                hMenuSelectNr(1)
                sleep(1)
                '///+open the breakpoint properties and check if the 'Active'-checkbox is unchecked for this breakpoint
                BreakPointsWindow.OpenContextMenu TRUE
                hMenuSelectNr(2)
                sleep(1)
                Kontext "Breakpoints"
                    BreakpointsList.Select(1)
                    if ActiveBox.IsChecked then warnlog "When a breakpoint is inactive and 'Active' is checked in breakpoints dialog => BUG!"
                    Breakpoints.Cancel
                    sleep(3)
                Kontext "BasicIDE"
                    BreakPointsWindow.OpenContextMenu TRUE
                    '///+open the context menu over the breakpoint and uncheck 'active'
                    printlog "- active"
                    hMenuSelectNr(1)
                    sleep(1)
                    '///+open the breakpoint properties and check if the 'Active'-checkbox is checked for this breakpoint
                    BreakPointsWindow.OpenContextMenu TRUE
                    hMenuSelectNr(2)
                    sleep(1)
                Kontext "Breakpoints"
                    BreakpointsList.Select(1)
                    if ActiveBox.IsChecked <> TRUE then Warnlog "When a breakpoint is active and 'Active'-checkbox is unchecked in breakpoints dialog => BUG!"
                    printlog "- delete the breakpoint"
                    '///delete the breakpoint
                    '///+ press 'delete' and leave the dialog with 'OK'
                    Remove.Click
                    Breakpoints.OK
                Kontext "BasicIDE"
                    BreakPointsWindow.MouseMove (50, yJump)
                    BreakPointsWindow.OpenContextMenu TRUE
                    '///+open the context menu over the breakpoint and uncheck 'active'
                    iMenuCountBrkPoint = hMenuItemGetCount
                    if hMenuItemGetCount <> 1 then Warnlog "Perhaps the breakpoint is not deleted, there is not 1 entry in the context menu, there are " & iMenuCountBrkPoint & " entries."  
                    hMenuClose
        end if
        '///insert breakpoints with breakpoints dialog ( at a code line )
        printlog "insert breakpoints with breakpoints dialog"
        '///+open context menu on breakpoints window
        printlog "- open breakpoints dialog out of context menu"
        Kontext "BasicIDE"
            BreakPointsWindow.OpenContextMenu
            hMenuSelectNr(1)
            sleep(1)
            '///+insert a breakpoint only with the line number ( without # ), set 1 and check if 'new' is active and the breakpoint can be inserted
            Kontext "Breakpoints"
                Call DialogTest ( Breakpoints )
                BreakpointsList.SetText "1"
                sleep(1)
                if NewButton.IsEnabled = FALSE then
                    warnlog "Insert a breakpoint only with the line-number is impossible ( new is disabled ) => #101478"
                else
                    NewButton.Click
                    Breakpoints.OK                    
                    Kontext "BasicIDE"
                        BreakPointsWindow.OpenContextMenu
                        hMenuSelectNr(1)
                        sleep(1)
                        Kontext "Breakpoints"
                            BreakpointsList.SetText "# 1"
                            if Remove.IsEnabled = FALSE then
                                warnlog "The Breakpoint isn't set for line 1 => BUG"
                            else
                                Remove.Click
                            end if
                end if
            '///+insert a breakpoint only with "# 5" and press new in the dialog
            printlog "- create a new breakpoint (#5)"
            Kontext "Breakpoints"
                BreakpointsList.SetText "#5"
                NewButton.Click
                sleep(2)
                BreakpointsList.Select(1)
                if BreakpointsList.GetSelText <> "# 5" then
                    sBrkPoiListEntry = 0
                    sBrkPoiListEntry = BreakpointsList.GetSelText
                    warnlog "The new breakpoint is not correct. Should '# 5'  is " & sBrkPoiListEntry & "   perhaps BugID:99372  => Test stops running!"
                    Breakpoints.Cancel
                    Call hCloseDocument
                    Call hCloseDocument                                            
                    goto endsub
                else
                    Breakpoints.OK
                    yJump = findBreakpointLine ("print")
                    BreakPointsWindow.MouseMove (50, yJump)
                    BreakPointsWindow.OpenContextMenu TRUE
                    if hMenuItemGetCount <> 2 then
                        if bAsianLan = FALSE then
                            warnlog "The breakpoint is not at the 5th line!"
                        end if
                        hMenuClose
                        Call hCloseDocument
                        Call hCloseDocument                        
                        goto endsub
                    else
                        hMenuClose
                    end if
                end if
        printlog "delete the breakpoints and close the dialog with 'cancel'"
        '///delete the breakpoint
        printlog "- open breakpoints dialog out of context menu"
        Kontext "BasicIDE"
            BreakPointsWindow.MouseMove(50, 2)
            BreakPointsWindow.OpenContextMenu TRUE
            hMenuSelectNr(1)
            sleep(1)
            '///+select the '# 5'-breakpoint and click on remove
            printlog "- select the '# 5'-breakpoint and click remove"
            Kontext "Breakpoints"
                Call DialogTest (Breakpoints)
                BreakpointsList.SetText "# 5"
                sleep(1)
                Remove.Click
                '///+leave the dialog with 'Cancel' => all changes must be canceled => Breakpoint on line 5 must be active
                printlog "- close the dialog with cancel and check if the breakpoint is not deleted"
                Breakpoints.Cancel
                sleep(1)
                '///+check if the breakpoint does exist
                yJump = findBreakpointLine ( "print" )
                BreakPointsWindow.MouseMove ( 50, yJump )
                BreakPointsWindow.OpenContextMenu TRUE
                if hMenuItemGetCount <> 2 then
                    warnlog "The breakpoint is deleted! Cancel does not cancel the changes in the dialog! => #99377"
                    hMenuSelectNr(1)
                else
                    hMenuSelectNr(2)
                end if
                printlog "delete the breakpoints"
                '///+delete the breakpoint
                '///+select the '# 5'-breakpoint and click on remove
                printlog "- select the '# 5'-breakpoint and click remove"
            Kontext "Breakpoints"
                Call DialogTest (Breakpoints)
                BreakpointsList.SetText "# 5"
                Remove.Click
                sleep(1)
                '///+leave the dialog with 'OK'
                printlog "- close the dialog with OK and check if the breakpoint is deleted"
                Breakpoints.OK
                sleep(1)
                '///+check if the breakpoint is deleted
                yJump = findBreakpointLine ( "print" )
                BreakPointsWindow.MouseMove ( 50, yJump )
                BreakPointsWindow.OpenContextMenu TRUE
                if hMenuItemGetCount <> 1 then Warnlog "The breakpoint is not deleted!"
                hMenuClose
        Call hCloseDocument
        Call hCloseDocument
endcase

