'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: t_tools2.inc,v $
'*
'*  $Revision: 1.6.4.1 $
'*
'*  last change: $Author: tbo $ $Date: 2003/09/09 20:40:44 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**************************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Global Tools II
'*
'***************************************************************************************
'*
' #1 GetDefaultFilternames 'Get the correct filtername for each language
' #1 GetOLEDefaultNames 'Get the correct language depending names for OLE objects
' #1 hMakeToOOo 'Converts StarOffice|Suite filter names to OpenOffice.org names
' #1 hSetLocaleStrings 'Set a string array with language dependant strings
' #1 GetHTMLCharSet 'Get the character set for HTML export
' #1 SetHTMLCharSet 'Set the character set for HTML export
' #1 SetHTMLCharSetToUTF8 'Set the character set for HTML export to UTF8
' #1 dec 'Decrease variable
' #1 inc 'Increase variable
' #1 ActivateAutoPilot 'Routine to activate (WebPage Autopilot, Form Autopilot, Documentconverter, Euroconveter and Addressdatasource)
' #1 SetURL 'Open a special URL with 'file open'-dialog
' #1 fGetFileText
'*
'\*************************************************************************************
sub GetDefaultFilternames
'TODO: JSI, describe it!
  Dim sFile as String
  Dim sFilterList(20) as String
  Dim sShort as String
  Dim i as Integer

   sFile = ConvertPath ( gTesttoolPath + "global\input\filters\filter" + iSprache + ".txt", gtPlatform)
   if Dir ( sFile ) = "" then
      Warnlog "t_tools2::GetDefaultFilternames(): The file for default-filter-names is missing, please create the list with ..\bas\tools\getnames.bas::GetFilterNames!"
      exit sub
   end if

   ListRead ( sFilterList(), sFile, "utf8" )

   for i=1 to ListCount ( sFilterList() )
      sShort = Left ( sFilterList(i), 2 )
      select case sShort
         case "sw" : gWriterFilter    = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "sc" : gCalcFilter      = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "si" : gImpressFilter   = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "sd" : gDrawFilter      = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "sm" : gMathFilter      = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "ht" : gHTMLFilter      = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "sg" : gMasterDocFilter = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
      end select
   next i

   if gOOO = TRUE then
      gWriterFilter    = hMakeToOOo ( gWriterFilter    )
      gCalcFilter      = hMakeToOOo ( gCalcFilter      )
      gImpressFilter   = hMakeToOOo ( gImpressFilter   )
      gDrawFilter      = hMakeToOOo ( gDrawFilter      )
      gMathFilter      = hMakeToOOo ( gMathFilter      )
      gHTMLFilter      = hMakeToOOo ( gHTMLFilter      )
      gMasterDocFilter = hMakeToOOo ( gMasterDocFilter )
   end if
end sub

'-------------------------------------------------------------------------

sub GetOLEDefaultNames
'TODO: JSI, describe it!
  Dim sFile as String
  Dim sFilterList(20) as String
  Dim sShort as String
  Dim i as Integer

   sFile = ConvertPath ( gTesttoolPath + "global\input\olenames\ole_" + iSprache + ".txt" )
   if Dir ( sFile ) = "" then
      Warnlog "The file for default-ole-names is missing, please create the list with ..\bas\tools\getnames.bas : GetOLEObjectNames!"
      exit sub
   end if

   if bAsianLan = TRUE then
      ListRead ( sFilterList(), sFile, "utf8" )
   else
      ListRead ( sFilterList(), sFile )
   end if

   for i=1 to ListCount ( sFilterList() )
      sShort = Left ( sFilterList(i), 2 )
      select case sShort
         case "sw" : gOLEWriter    = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "sc" : gOLECalc      = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "si" : gOLEImpress   = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "sd" : gOLEDraw      = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "sm" : gOLEMath      = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "sh" : gOLEChart     = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
         case "ot" : gOLEOthers    = Right ( sFilterList(i), Len ( sFilterList(i) ) -3 )
      end select
   next i

   if gOOO = TRUE then
      gOLEWriter    = hMakeToOOoOLE ( gOLEWriter  )
      gOLECalc      = hMakeToOOoOLE ( gOLECalc    )
      gOLEImpress   = hMakeToOOoOLE ( gOLEImpress )
      gOLEDraw      = hMakeToOOoOLE ( gOLEDraw    )
      gOLEMath      = hMakeToOOoOLE ( gOLEMath    )
      gOLEChart     = hMakeToOOoOLE ( gOLEChart   )
      gOLEOthers    = hMakeToOOoOLE ( gOLEOthers  )
   end if

end sub

'-------------------------------------------------------------------------

function hMakeToOOo ( FiltName as String ) as String
'TODO: JSI, describe it!
  Dim sDummy as String
  Dim iOffice as Integer, iSuite as Integer, iLen as Integer
   iOffice = Instr ( lcase (FiltName), "staroffice" )
   iSuite  = Instr ( lcase (FiltName), "starsuite" )
   iLen    = Len ( FiltName )
   if iOffice <> 0 then
      sDummy = Left ( FiltName, iOffice-1 ) + "OpenOffice.org 1.0" + Right ( FiltName, iLen-(iOffice+15) )
   else
      if iSuite <> 0 then
         sDummy = Left ( FiltName, iSuite-1 ) + "OpenOffice.org 1.0" + Right ( FiltName, iLen-(iSuite+14) )
      else
         sDummy = FiltName
      end if
   end if
   hMakeToOOo = sDummy
end function

function hMakeToOOoOLE ( FiltName as String ) as String
'TODO: JSI, describe it!
  Dim sDummy as String
  Dim iOffice as Integer, iSuite as Integer, iLen as Integer
   iOffice = Instr ( lcase (FiltName), "staroffice" )
   iSuite  = Instr ( lcase (FiltName), "starsuite" )
   iLen    = Len ( FiltName )
   if iOffice <> 0 then
      sDummy = Left ( FiltName, iOffice-1 ) + "OpenOffice.org 1.0" + Right ( FiltName, iLen-(iOffice+11) )
   else
      if iSuite <> 0 then
         sDummy = Left ( FiltName, iSuite-1 ) + "OpenOffice.org 1.0" + Right ( FiltName, iLen-(iSuite+10) )
      else
         sDummy = FiltName
      end if
   end if
   hMakeToOOoOLE = sDummy
end function

'-------------------------------------------------------------------------

function hSetLocaleStrings (fLocale as String, TBOstringLocale() as String ) as Boolean
'TODO: JSI, make real description from it!
' creator: TBO @ 25.10.2001
'/// function to set a string array with language dependant strings ///
'/// format of file (fLocale): ///
'///+ 1.line: entries/lines per language => x ///
'///+ 2.line: first language (A) number (iSprache) ///
'///+ 3.line: 1. string language A ///
'///+ 4.lin3: 2.language string  A ///
'///+ ... ///
'///+ (((x+1)*1) +2).line second language (B) number ///
'///+ (((x+1)*1) +2)+1.line:  1. string language B ///
'///+ ... ///
'///+ example file @ "input\\writer\\la_sp\\locale.txt" ///'
'
'/// the function parses the file until it finds the language (iSprache) or until EOF ///
'///+ on success the variable from th ecalling argument ///
'///+ gets set, ///
   dim lLocale (15*20) as string ' list, where file gets loaded into
   dim i,y,x as integer
   dim bFoundLanguage as Boolean
   hSetLocaleStrings = FALSE
   lLocale(0)=0
   fLocale = ConvertPath(fLocale)
   if ListRead (lLocale (), fLocale, "UTF8" ) then
'      printlog "LOCALE: read file :-)"

      bFoundLanguage = FALSE
  ' check file format
      if ( (ListCount(lLocale ()) -1) mod (val(lLocale (1))+1) ) <> 0 then
         warnlog "file has wrong format :-( : lines: "+ ListCount(lLocale ()) +", lenght of entries: "+ lLocale (1) +", (lenght -1) modulo lenghtOfEntries: "+ ( ListCount(lLocale ()) -1) mod ( val(lLocale (1)) +1 )
      else
      '                ( all lines in file  )          (trnsl words)
         for i=0 to ( ( (ListCount(lLocale ())-1) / (val(lLocale (1))+1) )-1)
           '    ( (val(lLocale (1))+1) *i+2)
            x = ( (val(lLocale (1))  ) *i+2 +i) ' line number of entry language
  ' print every language found:
'            printlog "position: "+i+" @ line: "+x+" Language: "+lLocale (x)
  ' check if at suspected language number position is a number
            if (val(lLocale (x)) > 0) then
  ' set string variable if it is the right language
               if (iSprache = val(lLocale (x))) then
'                  printlog "          ^ LOCALE: found needed language :-)"
                  for y=1 to val(lLocale (1))
                     TBOstringLocale(y) = lLocale (x+y)
                     if (TBOstringLocale(y) = "") then
                         qaErrorLog("missing string: " + y + ": '" + lLocale (2+y) + "'")
                     endif
                  next y
                  bFoundLanguage = TRUE
               endif
            else
               warnlog "LOCALE: this is no number :-( FileFormatError"
            end if
         next i
         if (bFoundLanguage = FALSE) then
            qaErrorLog "LOCALE: please add language to LOCALE file!: "+ iSprache
         endif
      endif
   else
      warnlog "LOCALE: file doesn't exist :-( : "+fLocale
   endif
   hSetLocaleStrings = bFoundLanguage
end function

'-------------------------------------------------------------------------

sub GetHTMLCharSet as String
'///function to get the Character Set for HTML export
'///+(tools/options/load&save/HTML compatibility -> Character Set)
   ToolsOptions
   hToolsOptions ( "LoadSave", "HTMLCompatibility" )
   GetHTMLCharSet = Zeichensatz.GetSelText
   Kontext "ExtrasOptionenDlg"
   ExtrasOptionenDlg.OK
end sub

'-------------------------------------------------------------------------

sub SetHTMLCharSet ( CharSet as String )
'///routine to set the Character Set for HTML export
'///+( tools/options/load&save/HTML compatibility -> Character Set )
   ToolsOptions
   hToolsOptions ( "LoadSave", "HTMLCompatibility" )
   Zeichensatz.Select CharSet
   Kontext "ExtrasOptionenDlg"
   ExtrasOptionenDlg.OK
end sub

'-------------------------------------------------------------------------

sub SetHTMLCharSetToUTF8 as Boolean
'///function to set the Character Set for HTML export to 'Unicode UTF8'
'///+( tools/options/load&save/HTML compatibility -> Character Set )
  Dim i as Integer
  Dim sDum as String

   ToolsOptions
   hToolsOptions ( "LoadSave", "HTMLCompatibility" )

   for i=1 to Zeichensatz.GetItemCount
      sDum = Zeichensatz.GetItemText (i)
      if Instr ( lcase (sDum), "utf-8" ) <> 0 then
         Zeichensatz.Select (i)
         i=1000
      else
         if Instr ( lcase (sDum), "utf8" ) <> 0 then
            Zeichensatz.Select (i)
            i=1000
         else
            if Instr ( lcase (sDum), "utf 8" ) <> 0 then
               Zeichensatz.Select (i)
               i=1000
            end if
         end if
      end if
   next i
   if i<1000 then
      SetHTMLCharSetToUTF8 = FALSE
   else
      SetHTMLCharSetToUTF8 = TRUE
   end if
   Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK
end sub

'-------------------------------------------------------------------------

function dec(Ref as integer)
'/// decrement variable, call it like 'dec variable' ///'
' reference or value .-) an excursion :-))
' to give this func a var as ref: call without ANY brackets => 'dec Variable'
' opposite of this to call it via value ! WE DON'T WANT THIS !
' (would be 'dec (Variable)' or in declaration 'function dec (ByVal x)')
   Ref = Ref - 1
end function

'-------------------------------------------------------------------------

function inc(Ref as integer)
'/// increment variable, call it like 'dec variable' ///'
   Ref = Ref + 1
end function

'-------------------------------------------------------------------------

function ActivateAutoPilot ( sWhichOne as String ) as Boolean
'Author: TZ
'///Routine to activate (WebPage Autopilot, Form Autopilot, Documentconverter and Euroconveter)
'///Open via menu items (not via SlotID or Macro URL)
'///<u>input</u>: Which Autopilot (<i>webpage</i>, <i>form</i>, <i>documentconverter</i>, <i>euroconverter</i>,<i>addressdatasource</i>)
'///<u>output</u>:<ul><li>TRUE: Autopilot is open</li><li>FALSE: Autopilot can not be opened</li></ul>
  Dim bIsLoaded as boolean, LoadTime as integer, PrintTime as Integer

   bIsLoaded = FALSE
   LoadTime = 0

   select case gApplication
      case "WRITER", "TEXTDOKUMENT"
                       Kontext "DocumentWriter"
                       DocumentWriter.UseMenu
      case "HTML", "HTMLDOKUMENT"
                       Kontext "DocumentWriterWeb"
                       DocumentWriterWeb.UseMenu
      case "MASTERDOC", "GLOBALDOKUMENT", "GLOBALDOC"
                       Kontext "DocumentMasterDoc"
                       DocumentMasterDoc.UseMenu
      case "CALC", "TABELLENDOKUMENT"
                       Kontext "DocumentCalc"
                       DocumentCalc.UseMenu
      case "IMPRESS", "PRAESENTATION"
                       Kontext "DocumentImpress"
                       DocumentImpress.UseMenu
      case "DRAW", "ZEICHNUNG"
                       Kontext "DocumentDraw"
                       DocumentDraw.UseMenu
      case "MATH", "FORMEL"
                       Kontext "DocumentMath"
                       DocumentMath.UseMenu
      case else
                       Kontext "DocumentWriter"
                       DocumentWriter.UseMenu
   end select
   sleep(2)
   hMenuSelectNr(1)
   sleep(2)
   hMenuSelectNr(3)
   sleep(2)

   select case lcase (sWhichOne)
      case "webpage"            : hMenuSelectNr(6)
      case "form"               : hMenuSelectNr(7)
      case "report"             : hMenuSelectNr(8)
      case "documentconverter"  : hMenuSelectNr(9)
      case "euroconverter"      : hMenuSelectNr(10)
      case "addressdatasource"  : hMenuSelectNr(12)
   end select
   sleep(5)

   while bIsLoaded = False
      while LoadTime < 20
         PrintTime = LoadTime * 3
         select case lcase ( sWhichOne )
            case "webpage"            : Kontext "AutopilotWebPage"
                                        if AutopilotWebPage.Exists(1) then
                                           bIsLoaded = true
                                           printlog "Autopilot is loaded in " + PrintTime + " seconds!"
                                           LoadTime = 20
                                           ActivateAutoPilot = TRUE
                                        end if
            case "report"             : Kontext "AutoPilotReport"
                                        if AutoPilotReport.Exists(1) then
                                           bIsLoaded = true
                                           printlog "Autopilot is loaded in " + PrintTime + " seconds!"
                                           LoadTime = 20
                                           ActivateAutoPilot = TRUE
                                        end if
            case "form"               : Kontext "ChooseDatabase"
                                        if ChooseDatabase.Exists(1) then
                                           bIsLoaded = true
                                           printlog "Autopilot is loaded in " + PrintTime  + " seconds!"
                                           LoadTime = 20
                                           ActivateAutoPilot = TRUE
                                        end if
            case "documentconverter"  : Kontext "DocumentConverter"
                                        if DocumentConverter.Exists(1) then
                                           bIsLoaded = true
                                           printlog "Autopilot is loaded in " + PrintTime + " seconds!"
                                           LoadTime = 20
                                           ActivateAutoPilot = TRUE
                                        end if
            case "euroconverter"      : Kontext "AutoPilotEuroKonverter"
                                        if AutoPilotEuroKonverter.Exists(1) then
                                           bIsLoaded = true
                                           printlog "Autopilot is loaded in " + PrintTime + " seconds!"
                                           LoadTime = 20
                                           ActivateAutoPilot = TRUE
                                        end if
            case "addressdatasource"  : Kontext "AddressSourceAutopilot"
                                        if AddressSourceAutopilot.Exists(1) then
                                           bIsLoaded = true
                                           printlog "Autopilot is loaded in " + PrintTime + " seconds!"
                                           LoadTime = 20
                                           ActivateAutoPilot = TRUE
                                        end if

         end select
         'NOTE: Maybe a messagebox occurs.
         Kontext "Active"
         if Active.Exists (1) then
            warnlog Active.GetText
            try
               Active.OK
            catch
               Active.Cancel
            endcatch
            ActivateAutoPilot = FALSE
         end if
         sleep(1)
         LoadTime = LoadTime + 1
         if LoadTime = 20 and bIsLoaded = False then
            warnlog "Autopilot has not been loaded!"
            ActivateAutoPilot = FALSE
            bIsLoaded = TRUE
         end if
      wend
   wend
end function

'-------------------------------------------------------------------------

function SetURL ( sURL as String )
'Author: TZ
'/// Routine to open a special URL with <i>file open</i>-dialog
'/// <ul>input</u>: The URL as string
  FileOpen
  Kontext "OeffnenDlg"
   Dateiname.SetText sURL
   Oeffnen.Click
   wait 500
end function

'-------------------------------------------------------------------------

function fGetFileText (sFilename as string, iCount as long) as string
'/// this function is for getting  the first or last n characters of a file ///'
'///+ INPUT : filename, number; if number > 0 then get n chars from start, < 0 get from end of file ///'
'///+ OUTPUT: string with n characters ///'

   dim iFile as integer ' filehandle
   dim iTem as integer  ' get 2 bytes of the file
   dim iTemByte(2) as integer ' move 1 byte from iTem in each item
   dim sTemp as string   ' string of file
   dim iSize as long  ' size in bytes of file
   dim i as long      ' runner :-)

   iFile = FreeFile
'   Printlog "FreeFile: " + iFile
   if (dir (sFilename) <> "") then
'      Printlog "FileLen: " + FileLen(sFile)
      Open sFilename For binary access read shared As #iFile
'      Printlog "Loc: " + Loc(#iFile)  ' LONG! where am i in the file?

      iSize = Lof(#iFile) ' get size in bytes of file
      if (iSize > 65530) then '65536 = 64kB
         'Warnlog "fGetFileText: file '" + sFilename + "' might get problems on reading it? size is > 65530 Byte: '" + iSize + "'"
      else
'         printlog "iSize: " + iSize
      endif

      sTemp = ""
      if (iCount >= 0) then   ' get bytes from file start
         get iFile,1,sTemp    ' get max 64kByte; but not the 1st 2 bytes :-(
         get iFile,1,iTem     ' get the first 2 bytes of the file
         iTemByte(2) = (iTem AND &H0000FF00) \ &H100   ' and seperate the bytes
         iTemByte(1) = (iTem AND &H000000FF)
         sTemp = chr(iTemByte(1)) + chr(iTemByte(2)) + sTemp  ' put them together
       else     ' get bytes from file end
         if ((iSize+iCount) > 0) then
               select case (iSize+iCount)
                  case 1: get iFile,1,sTemp ' take bytes from the end of the file
                          get iFile,1,iTem     ' get the first 2 bytes of the file
                          sTemp = chr(iTemByte(2)) + sTemp  ' put them together
                  case else: get iFile,(iSize+iCount)-1,sTemp ' take bytes from the end of the file
               end select
         else
            get iFile,1,sTemp ' take bytes from the end of the file
            get iFile,1,iTem     ' get the first 2 bytes of the file
            iTemByte(2) = (iTem AND &H0000FF00) \ &H100   ' and seperate the bytes
            iTemByte(1) = (iTem AND &H000000FF)
            sTemp = chr(iTemByte(1)) + chr(iTemByte(2)) + sTemp  ' put them together
         endif
       endif
'      printlog "'"+left(sTemp,iSize)+"'"  ' gotcha!

      if (iSize-(Abs(iCount)) >= 0) then
         fGetFileText = left(sTemp,Abs(iCount))
      else
         'Warnlog "fGetFileText: file '" + sFilename + "' isn't as big as expected; will only return '" + iSize+ "' bytes fom: " + iCount
         fGetFileText = left(sTemp,iSize)
      endif

   ' debugging routine --------------------------------------
   '   iSize = Lof(#iFile)
   '   printlog "iSize: " + iSize
   '   sTemp = ""
   '   if iSize > 0 then
   '      printlog "iSize \ 2: " + (iSize \ 2)
   '      for i = 0 to ((iSize \ 2)-1)
   '         get iFile,(i*2)+1,iTem
   '         Printlog "i: " + i + ": 0x" + hex(iTem)
   '       iTemByte(2) = (iTem AND &H0000FF00) \ &H100
   '       iTemByte(1) = (iTem AND &H000000FF)
   '         sTemp = sTemp + chr(iTemByte(1)) + chr(iTemByte(2))
   '      next i
   '      if (iSize MOD 2) = 1 then
   '         get iFile,iSize,iTem
   '         Printlog "i: " + iSize + ": 0x" + hex(iTem)
   '       iTemByte(1) = (iTem AND &H000000FF)
   '         sTemp = sTemp + chr(iTemByte(1))
   '      endif
   '   endif
   '   printlog "'"+sTemp+"'"
   ' debugging routine --------------------------------------
      Close #iFile
   else  ' does file exist
      Warnlog "fGetFileText: file '" + sFilename + "' doesn't exist"
      fGetFileText = ""
   endif
end function

'-------------------------------------------------------------------------

function wOptionenLayout() as string
'Author: HDE
'/// Sets the measurement unit to Centimeter and returns the unit ///
   Dim i as integer

    ToolsOptions
    Call hToolsOptions("Textdocument","General")
    Masseinheit.Select 2
    wOptionenLayout = Right$( Tabulatorenabstand.Gettext, 2 )
    Kontext "ExtrasOptionenDlg"
    ExtrasOptionenDlg.OK
end function

